(if (not (find-package :axiom.setup))
(defpackage axiom.setup
     (:use :cl :cl-web)
     (:export "pathname-to-string" "run-ext-program")))

(in-package :axiom.setup)

(defun pathname-to-string (file)
 #+sbcl (sb-ext:native-namestring file)
   )

(defun run-ext-program (string args out)
 #+sbcl (sb-ext:run-program string args :input nil :output out :wait t)
   )

(defun pamphletname-to-filename (file)
   (subseq (pathname-to-string file) 0 
           (position #\. (pathname-to-string file) :from-end t)))

;;*********cleanup********
	   
;; boot pamphlet files

(dolist (file (directory "../boot/*.boot"))
   (run-ext-program "/usr/bin/rm" (list (pathname-to-string file)) nil))

(dolist (file (directory "../boot/*.l*sp"))
   (run-ext-program "/usr/bin/rm" (list (pathname-to-string file)) nil))

#+sbcl(dolist (file (directory "../boot/*.fasl"))
        (run-ext-program "/usr/bin/rm" (list (pathname-to-string file)) nil))

;; interp pamphlet files

#+sbcl(dolist (file (directory "../interp/*.fasl"))
        (run-ext-program "/usr/bin/rm" (list (pathname-to-string file)) nil))

(dolist (file (directory "../interp/*.boot"))
   (run-ext-program "/usr/bin/rm" (list (pathname-to-string file)) nil))

(dolist (file (directory "../interp/*.l*sp"))
   (run-ext-program "/usr/bin/rm" (list (pathname-to-string file)) nil))

;; algebra files
   
#+sbcl(dolist (file (directory "../algebra/*.fasl"))
        (run-ext-program "/usr/bin/rm" (list (pathname-to-string file)) nil))
 
(dolist (file (directory "../algebra/*.spad"))
   (run-ext-program "/usr/bin/rm" (list (pathname-to-string file)) nil))


;; ***********start untangling***********

(time
(progn

(dolist (file (directory "../boot/*.l*sp.pamphlet"))
   (tangle (pathname-to-string file) (pamphletname-to-filename file)))

(dolist (file (directory "../boot/*.boot.pamphlet"))
   (tangle (pathname-to-string file) (pamphletname-to-filename file)))

;; In the case of boot, there are special steps which need to be taken in order to bootstrap the language.
;; Because of that, the .boot files in this directory also contain lisp code, which will be needed.
(tangle "../boot/ptyout.boot.pamphlet" "../boot/ptyout.lisp" "ptyout.clisp" )
(tangle "../boot/btincl2.boot.pamphlet" "../boot/btincl2.lisp" "btincl2.clisp")
(tangle "../boot/typrops.boot.pamphlet" "../boot/typrops.lisp" "typrops.clisp")
(tangle "../boot/btpile2.boot.pamphlet" "../boot/btpile2.lisp" "btpile2.clisp")
(tangle "../boot/btscan2.boot.pamphlet" "../boot/btscan2.lisp" "btscan2.clisp")
(tangle "../boot/typars.boot.pamphlet" "../boot/typars.lisp" "typars.clisp" )
;(tangle "../boot/tyextra.boot.pamphlet" "../boot/tyextra.lisp" "tyextra.clisp")
(tangle "../boot/tytree1.boot.pamphlet" "../boot/tytree1.lisp" "tytree1.clisp")

(dolist (file (directory "../interp/*.l*sp.pamphlet"))
   (tangle (pathname-to-string file) (pamphletname-to-filename file)))

(dolist (file (directory "../interp/*.boot.pamphlet"))
   (tangle (pathname-to-string file) (pamphletname-to-filename file)))

(tangle "../interp/bookvol5.pamphlet" "../interp/bookvol5.lisp" "Interpreter")

(dolist (file (directory "../algebra/*.spad.pamphlet"))
   (tangle (pathname-to-string file) (pamphletname-to-filename file)))


 ))

